<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
class ip{
  public $cidr='',$first='',$last='',$firstlong='',$lastlong='';
	function __construct($s){
    $s=str_replace(' ','',$s);
    if(self::sp($s,'-')){
      $a=explode('-',$s);
      $b=self::clear($a[0],0,['/','*']);
      $this->first=$b[0];
      $b=self::clear($a[1],0,['/','*']);
      $this->last=$b[0];
    }elseif(self::sp($s,'/')){
      $a=explode('/',$s);
      $b=self::clear($a[0],0,['*']);
      $this->cidr=self::cidrverify($a[1],$b[1]);
      $m=self::cidr2mask($this->cidr,$b[1]);
      $b=inet_pton($b[0]);
      $m=inet_pton($m);
      $this->first=inet_ntop($b&$m);
      $this->last=inet_ntop($b|~$m);
    }elseif(self::sp($s,'*')){
      $a=explode('*',$s);
      $b=self::clear($a[0]);
      $this->first=$b[0];
      $b=self::clear($a[0],1);
      $this->last=$b[0];
    }else{
      $a=self::clear($s);
      $this->first=$a[0];
      $a=self::fill($s);
      if($a[1]){
        $a=self::clear($s,1);
        $this->last=$a[0];
      }
    } 
    $this->firstlong=self::tolong($this->first);
    if(''!=$this->last)$this->lastlong=self::tolong($this->last);
	}
	static function cidr2bin($i,$v=4){
	  return str_pad(str_pad('',(int)$i,'1'),4==$v?32:128,'0');
	}
	static function cidr2mask($i,$v=4){
		return self::frombin(self::cidr2bin(self::cidrverify($i,$v),$v));
	}
	static function cidrverify($i,$v=4){
    $i=(int)$i;
    $m=4==$v?32:128;
    if($i>$m || 0>$i)$i=$m;
	  return $i;
	}
	static function clear($s,$f=0,$a=[]){
    $s=str_replace(' ','',$s);
    if(''==$s)$s='0';
    if(self::isint($s) && isset($s[4]))$s=self::fromlong($s);
    foreach($a as $k=>$v){
      if(self::sp($s,$v)){$a=explode($v,$s);$s=$a[0];}
    }
    $a=self::fill($s,$f);$s=$a[0];
    $v=self::ver($s);
    if(6==$v){
      $t=self::v6to4($s);
      if(''!=$t){$s=$t;$v=4;}
      else $s=inet_ntop(inet_pton($s));
    } return [0=>$s,1=>$v];
	}
  static function compress($s,$m=1){
    $s=str_replace(' ','',$s);$c='';
    if(self::sp($s,'/')){$a=explode('/',$s);$s=$a[0];$c='/'.$a[1];}
    if(6==self::ver($s)){
      $s=inet_ntop(inet_pton($s));
      if(!$m && self::sp($s,'.'))$s=str_replace('0:0:0:0:0',':',self::expand($s,0));
    } return $s.$c;
  }
	static function count($f,$l=0){
    if(!self::isint($f))$f=self::tolong($f);
    if(!self::isint($l))$l=self::tolong($l);
    $f=1==bccomp($f,$l)?bcsub($f,$l):bcsub($l,$f);
		return bcadd($f,1);
	}
  static function expand($s,$f=1){
    $f=$f?'%04x':'%x';
    $s=str_replace(' ','',$s);$c='';
    if(self::sp($s,'/')){$a=explode('/',$s);$s=$a[0];$c='/'.$a[1];}
    if(6==self::ver($s)){
      $a=unpack('n*',inet_pton($s));
      $s=implode(':',array_map(function($s)use($f){return sprintf($f,$s);},$a));
    } return $s.$c;
  }
	static function fill($s,$f=0){
    $r=0;$c='';
    if(self::isint($s) && isset($s[4]))return [$s,0];
    if(self::sp($s,'/')){$a=explode('/',$s);$s=$a[0];$c='/'.$a[1];}
    $v=self::sp($s,':') && !self::sp($s,'.');
    if($v){$l=7;$d=':';$f=$f?'ffff':'0';}else{$l=3;$d='.';$f=$f?'255':'0';}
    if(!($v && self::sp($s,'::'))){
      $s=rtrim($s,$d); 
      $z=substr_count($s,$d);
      if($l>$z){
        $r=1;$d=$d.$f;$m=strlen($d);
        $s.=str_pad('',($l-$z)*$m,$d);
      }
    } return [0=>$s.$c,1=>$r];
	}
	static function frombin($s){
		$r='';foreach(array_map('bindec',str_split($s,8)) as $b)$r.=pack('C*',$b);
		return inet_ntop($r);
	}
	static function fromlong($s){
		if(4==self::ver($s))$s=long2ip($s);
		else{$a=[];
			for($i=0;$i<16;$i++){
				$a[]=bcmod($s,256);
				$s=bcdiv($s,256,0);
			} $s=inet_ntop(call_user_func_array('pack',array_merge(['C*'],array_reverse($a))));
		} return $s;
	}
	function in($s){
    $r=0;$i=new stdClass();
    $a=explode(';',str_replace(',',';',$s));
    foreach($a as $k=>$v){
      $i=new self($v);
      if(self::inlong($this->firstlong,$i->firstlong,$i->lastlong)){$r=1;break;}
    } return $r;
	}
	static function inlong($i,$f,$l=''){
    $r=0;
    if($i==$f)$r=1;
    elseif(''!=$l){
      if($i==$l)$r=1;
      elseif(1==bccomp($i,$f) && -1==bccomp($i,$l))$r=1;
    } return $r;
	}
  static function isint($v=''){
    return ctype_digit((string)$v);
  }
	function get($f=1,$l=0){
    $r='';
    if(1==$f)$r=$l?$this->firstlong:$this->first;
    else $r=$l?$this->lastlong:$this->last;
		return $r;
	}
  static function long2bin($s,$v=0){
    if(!$v)$v=self::ver($s);
    $v=4==$v?32:128;
    $b='';
    while($s){
      $m=bcmod($s,'2');
      $s=bcdiv($s,'2',0);
      $b=abs($m).$b;
    }
    if(''==$b)$b=str_pad('',$v,'0');
    else $b=str_pad($b,$v,'0',STR_PAD_LEFT);
    return $b;
  }
	static function tobin($s,$v=4){
    $s=inet_pton(str_replace(' ','',$s));
		$a=[];foreach(unpack('C*',$s) as $b)$a[]=str_pad(decbin($b),8,'0',STR_PAD_LEFT);
    $s=implode($a);
		return ''==$s?str_pad('',4==$v?32:128,'0'):$s;
	}
	static function tolong($s,$v=0){
    $s=str_replace(' ','',$s);
    if(!$v)$v=self::ver($s);$l=0;
		if(4==$v)$l=sprintf('%u',ip2long($s));
		else{$i=15;//v6=16 v4=4
      foreach(unpack('C*',inet_pton($s)) as $b)$l=bcadd($l,bcmul($b,bcpow(256,$i--)));
		} return $l;
	}
  static function shorten($s){
    return self::expand($s,0);
  }
  static function sp($s,$f){
    return false!==mb_strpos($s,$f);
  }
  static function v4to6($s,$m=1){
    return self::compress('::ffff:'.$s,$m);
  }
  static function v6to4($s){
    $s=rtrim(inet_ntop(inet_pton(str_replace(' ','',$s))),':');
    $s=preg_replace('#^2002#','::ffff',$s);
    $s=str_replace('::ffff:','',self::compress($s));
    return 4==self::ver($s)?$s:'';
  }
  static function ver($s){
    $r=0;$s=str_replace(' ','',$s);
    if(self::isint($s))$r=1==bccomp($s,'4294967295')?6:4;
    elseif(filter_var($s,FILTER_VALIDATE_IP,FILTER_FLAG_IPV4))$r=4;
    elseif(filter_var($s,FILTER_VALIDATE_IP,FILTER_FLAG_IPV6))$r=6;
    return $r;
  }
}