<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
if(!isset($kruglet)){
function fdate($f='d.m.Y',$t=T,$j=L,$n=0){
  global $l;
  $j=loadl('date',$j);
  $a=explode('.',date('w.n',$t));
  $d=$l['date'][$j]['days'][$a[0]];
  $m=$l['date'][$j]['months'][$a[1]];
  if($n)$m=str_replace($l['date'][$j]['genitive'],$l['date'][$j]['nominative'],$m);
  $d3=addcslashes(mb_substr($d,0,3),'A..z');
  $m3=addcslashes(mb_substr($m,0,3),'A..z');
  $f=str_replace(['F','M','l','D'],[addcslashes($m,'A..z'),$m3,addcslashes($d,'A..z'),$d3],$f);
  return date($f,$t);
}
//Круголѣт Числобога / Коляды даръ. Лѣта от С.М.З.Х. (Slavic calendar)
$kruglet=[
'ms'=>[1=>null,2=>null,//Начало месяца по Славяно-Арийскому Календарю. Лѣта 1-16; Сороковники(месяцы) 0-8 (Рамхатъ..)
3=>['23.09','03.11','13.12','23.01','04.03','14.04','24.05','04.07','13.08'],//365 дней день.месяц
4=>['23.09','03.11','13.12','23.01','03.03','13.04','23.05','03.07','12.08'],5=>null,6=>null,//365, григорианский 4-й високосный 366
7=>['22.09','02.11','12.12','22.01','03.03','13.04','23.05','03.07','12.08'],
8=>['22.09','02.11','12.12','22.01','02.03','12.04','22.05','02.07','11.08'],9=>null,10=>null,
11=>['21.09','01.11','11.12','21.01','02.03','12.04','22.05','02.07','11.08'],
12=>['21.09','01.11','11.12','21.01','01.03','11.04','21.05','01.07','10.08'],13=>null,14=>null,
15=>['20.09','31.10','10.12','20.01','01.03','11.04','21.05','01.07','10.08'],
16=>['20.09','31.10','11.12','21.01','02.03','12.04','23.05','03.07','13.08']],//369 Священное, в месяцах по 41 дню
'first'=>[//С какого дня началось лѣто 
1=>[1,10,20,29,39,48,49,58,68,77,87,96,106,116,125,135,144],//Понедельникъ
2=>[3,12,22,31,41,51,60,70,79,89,99,108,118,127,137],
3=>[5,14,24,34,43,53,62,72,82,91,97,101,110,120,130,139],
4=>[7,16,17,26,36,45,55,64,65,74,84,93,103,112,113,122,132,141],
5=>[9,19,28,38,47,57,67,76,86,95,105,115,124,134,143],
6=>[2,11,21,30,40,50,59,69,78,88,98,107,117,126,136],
7=>[4,13,23,32,33,42,52,61,71,80,81,90,100,109,119,128,129,138],
8=>[6,15,25,35,44,54,63,73,83,92,102,111,121,131,140],
9=>[8,18,27,37,46,56,66,75,85,94,104,114,123,133,142]],
'simple'=>[1=>6,6=>2,2=>7,7=>3,3=>8,8=>4,4=>9,9=>5,5=>1],
'saint'=>[[1=>1,4=>4,7=>7],[1=>6,4=>9,7=>3],[1=>2,4=>5,7=>8],[1=>7,4=>1,7=>4],[1=>3,4=>6,7=>9],[1=>8,4=>2,7=>5],[1=>4,4=>7,7=>1],[1=>9,4=>3,7=>6],[1=>5,4=>8,7=>2]]];
//$f = Формат вывода:
//дата: d.m.Y=05.1.7529;   j.n=5.1;   время: G | H:i:s - 9 | 09:142:0518
//I - зимнее / летнее время           N - дата начала лѣта - 21.09.2020
//l - название дня недели (Осьмица)   D - сокращенное наименование дня недели, 3 символа
//F - название сороковника (месяца)   M - cокращенное наименование сороковника, 3 символа
//Q - название чертога                q - номер чертога
//b - бог/иня покровитель чертога     C - священное дерево чертога
//K - лѣто в круге жизни (144)        k - лѣто в круге лѣт (16)
//f - название лѣта (Жрец)            u - энергия лѣта
//E - образ структуры стихии лѣта     e - цвет лѣта
//P - первый день в лѣте              p - первый день в этом сороковнике
//W - номер недели лѣта               w - номер дня недели
//J - бог/иня покровитель дня         R - описание дня (трудовой/отдых)
//V - пора суток: Утро                v - название часа: Заутра
//X - пора лѣта                       x - описание сороковника
//z	- номер дня в лѣте
//$t = Unix time or string: 'Y[.m[.d[.H[.i[.s]]]]]' (или d.m.Y[.H[.i[.s]]]). Разделитель может быть любой: 2020.08.03 22:59:20
//  0=>Год 2020, 1=>Месяц 01-12, 2=>День 01-31, 3=>Час 00-23, 4=>Минуты 00-59, 5=>Секунды 00-59
//$r = Обратное преобразование в григорианский
//$j = Язык
//$s = Учитывать переход на летнее время (по солнцу правильно зимнее).
function krugolet($f='d.m.Y',$t=T,$r=0,$j=L,$s=1){
  global $kruglet,$l;
  $j=loadl('date',$j);
  $i=5>mb_strlen($t);
  if($r || $i)$t=(string)$t;
  if(is_string($t)){
    $t=trim($t);
    if($i)$d=[0=>$t];
    else{
      if(preg_match('#\D#',$t)){
        $t=preg_replace('#\D+#','.',$t);
        $d=explode('.',rtrim($t,'.'));
        if(isset($d[2]) && 4>mb_strlen($d[0])){$i=$d[0];$d[0]=$d[2];$d[2]=$i;}//d.m.Y->Y.m.d
      }else{
        if(16<=mb_strlen($t))$t=mb_substr($t,0,4).'.'.mb_substr($t,4,1).'.'.mb_substr($t,5,2).'.'.mb_substr($t,7,2).'.'.mb_substr($t,9,3).'.'.mb_substr($t,12,4);
        else $t=mb_substr($t,0,4).'.'.mb_substr($t,4,2).'.'.mb_substr($t,6,2).'.'.mb_substr($t,8,2).'.'.mb_substr($t,10,2).'.'.mb_substr($t,12,2);
        $d=explode('.',rtrim($t,'.'));
      }
    }
    for($i=1;$i<6;$i++){
      if(!isset($d[$i]))$d[$i]=3>$i?1:0;
    } if(3==$r)return $d;
  }elseif(!$r)$d=explode('.',date('Y.m.d.H.i.s',$t));
  if($r){//преобразование в григорианский
    $hour=$d[3];
    if(4<$hour)$hour-=4;//00:00 = 4:000:0000
    else $hour+=12;
    $hour*=1.5;
    if(24==$hour)$hour=0;
    $min=$d[4]/1.6;
    $sec=$d[5]/34.56;
    $t=$hour*3600+$min*60+$sec;
    $hour=floor($t/3600);$t-=$hour*3600;
    $min=ceil($t/60)-1;$t-=$min*60;
    $sec=ceil($t);
    if(59<$sec){$sec=60-$sec;$min++;}
    $t=$d[0]-7520;while(0>$t)$t+=144;
    $krug=$t%144;if(!$krug)$krug=144;
    $leto=$krug%16;if(!$leto)$leto=16;
    $fday=23-(($leto-1)/4)%4;
    $year=$d[0]-5508;
    $m=$kruglet['ms'][$leto]??$kruglet['ms'][$leto+1]??$kruglet['ms'][$leto+2];
    while(9<$d[1]){$d[1]-=9;$year++;}
    $n=explode('.',$m[$d[1]-1]);
    if($n[1]>9 || ($n[1]==9 && $n[0]>=$fday))$year--;
    if(17<$hour)$d[2]--;
    $t=mktime($hour,$min,$sec,$n[1],$n[0]+$d[2]-1,$year);
    $st=date('I',$t+3600);
    if($s && $st)$t+=3600;//летнее время - прибавялем час
    if(2==$r)return $t;//Unix time 
    else return fdate($f,$t);
  }
  $year=$d[0];
  if(24==$d[3])$d[3]=0;
  if(60==$d[4])$d[4]=0;
  if(60==$d[5])$d[5]=0;
  $st=date('I',mktime($d[3],$d[4],$d[5],$d[1],$d[2],$year));
  $t=17<$d[3];
  if($t || $s){
    if($t)$d[2]++;
    if($s && $st)$d[3]--;//летнее время(на 1 час вперёд) - вычитаем час   
    $d=explode('.',date('Y.m.d.H.i.s',mktime($d[3],$d[4],$d[5],$d[1],$d[2],$year)));
  }
  $smzh=$year+5508;
  $t=($smzh+1)%16;if(!$t)$t=16;$t=23-(($t-1)/4)%4;//лѣта 1-4=23 число; 5-8=22; 9-12=21; 13-16=20
  $next=9<$d[1] || 9==$d[1] && $d[2]>=$t?1:0;//следующее лето
  $smzh+=$next;
  $t=$smzh-7520;while(0>$t)$t+=144;//7520 последнее(144) лѣто прошлого круга
  $krug=$t%144;if(!$krug)$krug=144;//лѣто в круге жизни
  $leto=$krug%16;if(!$leto)$leto=16;//в круге лет
  $m=$kruglet['ms'][$leto]??$kruglet['ms'][$leto+1]??$kruglet['ms'][$leto+2];
  $yearstart=$next?$year:$year-1;
  if($next && $year==$yearstart){$month=0;$e=-1;}//дата в начале года
  else{$month=2;$e=2;}//в следующем
  $t=(int)$d[2];$md=$d[1].'.'.(10>$t?'0'.$t:$t);
  $k=$n=0;
  for($i=8;$i>$e;$i--){
    $a=explode('.',$m[$i]);
    $k=$a[1].'.'.$a[0];
    if($md>=$k && $n<$k){$n=$k;$month=$i;}
    $t=$k;
  }
  $a=explode('.',$m[$month]);
  $t=23-(($leto-1)/4)%4;
  $d1=mktime(0,0,0,9,$t,$yearstart);
  $yearstart=$m[0].'.'.$yearstart;
  $d2=mktime(0,0,0,$d[1],$d[2],$year);
  $yearday=(int)(($d2-$d1)/86400)+1;
  $daysleft=16==$leto?41*$month:40*$month+(int)(($month+1)/2);//1 3 5 7 9 по 41 дню, $month/2: 1=0 2=1 3=1 4=2 5=2 6=3 7=3 8=4 9=4
  $day=$yearday-$daysleft;
  $firstday=1;for($i=1;$i<10;$i++)if(in_array($krug,$kruglet['first'][$i])){$firstday=$i;break;}//первый день в лѣте
  $monthfirst=16==$leto?$kruglet['saint'][$month][$firstday]:(($month+1)%2?$firstday:$kruglet['simple'][$firstday]);
  $w=($monthfirst+$day-1)%9;if(!$w)$w=9;//день недели
  $monthweek=ceil(($yearday+10-$firstday)/9);
  $month++;
  //новые сутки: 19:30 = 1:000:0000; 18:00 заход солнца - конец суток (16:000:0000 час завершения, 00:00 на современный лад)
  $hourf=$d[3]/1.5;//1/16 = 1.5/24
  $houri=(int)$hourf;
  $hour=($houri+4)%16;if(!$hour)$hour=16;
  $min=$mint=$d[4];//1.6/16 = 1/24
  if($houri<$hourf){
    $t=($hourf-$houri>.5);
    if($min<30){
      $mint=$min+30;
      if($t)$mint+=30;
    }else{
      $mint=$min-30;
      if($t){$hour=($hour+1)%16;if(!$hour)$hour=16;}
      else $mint+=60;
    }
  }
  $t=$mint*60+$d[5];//sec
  $chast=(int)($t*1.6/60);
  $dolya=($t*34.56)%1296;
  $ds=((int)($hour/4)+1)%4;if(!$ds)$ds=4;
  $cn=0;$n=$month.'.'.(10>$day?'0'.$day:$day);//now
  foreach($l['kruglet'][$j]['chertog'] as $k=>$v){
    ++$cn;
    $i=explode('.',$v[3]);//from
    $t=explode('.',$v[4]);//to
    $i=$i[1].'.'.$i[0];//месяц.день
    $t=$t[1].'.'.$t[0];
    if($n>$i && $n<$t)break;
    if($n==$t && $hour<14)break;
    if($n==$i && $hour>=14)break;
    if($n>'9.18'){$cn=1;break;}
  }
  $chertog=$l['kruglet'][$j]['chertog'][$cn][0];
  $god=$l['kruglet'][$j]['chertog'][$cn][1];
  $tree=$l['kruglet'][$j]['chertog'][$cn][2];
  $e=$krug%18;if(!$e)$e=18;
  $e=(int)($e/2+.5);
  $xy=(0==$krug%2)?1:2;
  if(4<$month && 8>$month)$ty=3;//Весна
  elseif(1<$month && 5>$month)$ty=2;//Зима
  else $ty=1;//Оусень
  $ty=$l['kruglet'][$j]['season'][$ty];
  $t=mb_strlen($chast);while(3>$t){$chast='0'.$chast;$t++;}
  $t=mb_strlen($dolya);while(4>$t){$dolya='0'.$dolya;$t++;}
  $d=$l['kruglet'][$j]['day'][$w];
  $m=$l['kruglet'][$j]['month'][$month];
  $f=str_replace('\\','~',$f);
  $f=preg_replace('#(?<!~)(\w)#','^$1',$f);
  $f=str_replace(['^Y','^n','^m','^F','^M','^l','^D','^j','^d',   '^G','^H','^i','^s','^K','^k','^N','^P','^p',
                  '^W','^w','^V','^v','^f','^q','^Q','^b','^C',   '^J','^R','^E','^e','^u','^X','^x','^z','^I'],
    [$smzh,$month,$month,$m,mb_substr($m,0,3),$d,mb_substr($d,0,3),$day,(10>$day?'0'.$day:$day),
     $hour,(10>$hour?'0'.$hour:$hour),$chast,$dolya,$krug,$leto,$yearstart,$l['kruglet'][$j]['day'][$firstday],$l['kruglet'][$j]['day'][$monthfirst],
     $monthweek,$w,$l['kruglet'][$j]['daystage'][$ds],$l['kruglet'][$j]['hour'][$hour],$l['kruglet'][$j]['leto'][$leto],$cn,$chertog,$god,$tree,
     $l['kruglet'][$j]['daygod'][$w],$l['kruglet'][$j]['dayrest'][$w],$l['kruglet'][$j]['element'][$e],$l['kruglet'][$j]['color'][$e],
       $l['kruglet'][$j]['energy'][$xy],$ty,$l['kruglet'][$j]['months'][$month],$yearday,$l['kruglet'][$j]['time'][$st]],$f);
  return str_replace(['~','^'],'',$f);
}
}